#include "sphere.cuh"

__device__ T Sphere::distance_estimator(vect3 point) const {
  return length(this->pos_ - point) - r_;
}

__device__ Color Sphere::get_color(struct Ray ray) const {
  return normalize(ray.start);
}
